//XXXXXXXXXXXXXXXXXXXXX S E T T I N G S XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//TREE
#declare BRANCHES=7;
#declare TWIGS=5*BRANCHES;
#declare BUNCHES=3*TWIGS;
#declare LEAVES=200*BUNCHES;
#declare BLOSSOMS=0*BUNCHES;
#declare ROOTS=4;
#declare BRANCH_RANDOM=15.397; 
#declare TWIG_RANDOM=77.37;
#declare ROOT_RANDOM=173;
//TRUNK
#declare TRUNK_RADIUS=20;
#declare TRUNK_STRENGTH=.5;
#declare TRUNK_BEND_X=15;
#declare TRUNK_BEND_Z=20;
#declare TRUNK_BEND_X_FREQUENCY=1.5;
#declare TRUNK_BEND_Z_FREQUENCY=1.5;
#declare TRUNK_CURVE=10;
#declare TRUNK_CURVE_FREQUENCY=5;
#declare TRUNK_SNAG=5;
#declare TRUNK_SNAG_FREQUENCY=10;
#declare TRUNK_SPIRAL=50;
#declare TRUNK_TAPER=0.2;
#declare FIRST_BRANCH_AT_TRUNK=300;
#declare BRANCH_AREA_AT_TRUNK=300;
//BRANCH
#declare BRANCH_THICKNESS_CHANGE=.7;
#declare BRANCH_STRENGTH=1;
#declare BRANCH_BEND=-30;
#declare BRANCH_BEND_FREQUENCY=2;
#declare HORIZONTAL_BRANCH_BEND_SWITCH=1;
#declare EXTRA_NOISE_SWITCH=1;
#declare BRANCH_CURVE=-5;
#declare BRANCH_CURVE_FREQUENCY=2;
#declare HORIZONTAL_BRANCH_CURVE_SWITCH=1;
#declare BRANCH_LONGITUDINAL_CURVE=.5;
#declare BRANCH_SNAG=3;
#declare BRANCH_SNAG_FREQUENCY=5;
#declare BRANCH_REDUCTION=.0;
#declare BRANCH_TAPER=.2;
#declare BRANCH_END_EQUALIZER=1;
#declare BRANCH_TIP=0;
#declare BRANCH_TURN_SWITCH=1;
#declare BRANCH_ALTERNATE_SWITCH=0;
#declare BRANCH_SPIRAL=0;
#declare BRANCH_ANGLE=35;
#declare BRANCH_ANGLE_SCOPE=0;
#declare BRANCH_ALIGNMENT=.8;
#declare STRAIGHTEN_TOWARDS_TOP=0.6;
#declare FIRST_TWIG_AT_BRANCH=50;
#declare TWIG_AREA_AT_BRANCH=100;
//TWIG
#declare TWIG_STRENGTH=.5;
#declare TWIG_THICKNESS_CHANGE=.55;
#declare HORIZONTAL_TWIG_ANGLE=0;
#declare VERTICAL_TWIG_ANGLE=30;
#declare HORIZONTAL_TWIG_ANGLE_SCOPE=0;
#declare VERTICAL_TWIG_ANGLE_SCOPE=0;
#declare HORIZONTAL_TWIG_ALIGNMENT=1;
#declare VERTICAL_TWIG_ALIGNMENT=1;
#declare TWIG_TURN_SWITCH=1;
#declare TWIG_ALTERNATE_SWITCH=0;
#declare TWIG_CURVE_ADJUSTMENT=.8;
#declare TWIG_CURVE_FREQUENCY_ADJUSTMENT=1;
#declare TWIG_TAPER=1;
#declare TWIG_TIP=0;
#declare STRAIGHTEN_TOWARDS_BRANCH_END=0;
#declare TWIG_RAMIFICATION_ORDER=3;
#declare LAST_RAMIFICATION_NUMBER=5;
#declare TWIG_RAMIFICATION_THICKNESS_CHANGE=1;
#declare TWIG_RAMIFICATION_CURVE_ADJUSTMENT=1;
#declare RAMI_CURVE_FREQUENCY_ADJUSTMENT=1;
#declare TWIG_RAMIFICATION_STRENGTH=.5;
#declare FIRST_BUNCH_AT_TWIG=100;
#declare BUNCH_AREA_AT_TWIG=150;
//BUNCH
#declare BUNCH_MAJOR_RADIUS=150;
#declare BUNCH_MINOR_RADIUS=50;
#declare HORIZONTAL_BUNCH_FUNNEL=40;
#declare VERTICAL_BUNCH_FUNNEL=40;
#declare ROTATION_BUNCH_FUNNEL=0;
#declare HORIZONTAL_BUNCH_ANGLE=0;
#declare VERTICAL_BUNCH_ANGLE=30;
#declare HORIZONTAL_BUNCH_ANGLE_SCOPE=5;
#declare VERTICAL_BUNCH_ANGLE_SCOPE=5;
#declare BUNCH_TURN_SWITCH=1;
#declare BUNCH_TURN_SHIFT=1;
#declare BUNCH_ALTERNATE_SWITCH=0;
#declare HORIZONTAL_BUNCH_ALIGNMENT=1;
#declare VERTICAL_BUNCH_ALIGNMENT=1;
#declare BUNCH_TAPER_OFF_AT_TWIG=.3;
#declare BUNCH_TAPER_OFF_AT_BRANCH=-.3;
#declare BUNCH_TAPER_OFF_AT_TREE=0;
#declare BUNCH_ARC_AT_TWIG=<0,0,0>; 
#declare BUNCH_ARC_AT_BRANCH=<0,0,0>;
#declare BUNCH_DEFORM=<1,1,1>;
//LEAF 
#include "TOMLEAF.inc"
#declare LEAF_TYPE=HF_SIMPLELEAF
#declare LEAF_LENGTH=10;
#declare LEAF_BREADTH=7;
#declare LEAF_HEIGHT=1;
#declare MAX_LEAF_TILT=30;
#declare MAX_LEAF_TURN=30;
#declare LEAF_INCLINATION=50;
#declare LEAF_INCLINATION_SCOPE=10;
//BLOSSOM
#declare BLOSSOM=LEAF
#declare BLOSSOM_LENGTH=50;
#declare BLOSSOM_WIDTH=100;
#declare BLOSSOM_INCLINATION=0;
#declare BLOSSOM_COLOR=<1,1,1>;
//ROOT
#declare FIRST_ROOT_AT_TRUNK=30;
#declare ROOT_LENGTH=200;
#declare ROOT_THICKNESS_CHANGE=.6;
#declare ROOT_STRENGTH=1;
#declare ROOT_BEND=50;
#declare ROOT_BEND_FREQUENCY=1;
#declare ROOT_CURVE=30;
#declare ROOT_CURVE_FREQUENCY=5;
#declare ROOT_SNAG=5;
#declare ROOT_SNAG_FREQUENCY=15;
#declare ROOT_TURN_SWITCH=1;
#declare ROOT_ANGLE=30;
#declare ROOT_ALIGNMENT=.6;
//BARK
#declare SUNKEN_TRUNK_COLOR=<-.1,-.1,-.1>;
#declare RAISED_TRUNK_COLOR=<1,1,1>;
#declare FOLIAGE_COLOR_AT_BRANCH_END=1;
#declare TRUNK_SCAR_WIDTH=60;
#declare TRUNK_SCAR_HEIGHT=15;
#declare HORIZONTAL_SCAR_SHRINKING=.2;
#declare VERTICAL_SCAR_SHRINKING=2;
#declare SCAR_DEPTH=-1; 
#declare PALM_TRUNK=0.2;
#declare BARK_PROFILE=0;
#declare BRANCH_BARK_PROFILE_CHANGE=0;
#declare BRANCH_BARK_PROFILE_TAPER_OFF=1;
#declare ROOT_BARK_PROFILE_CHANGE=0;
//FOLIAGECOLOR
#declare BOTTOM_COLOR_1=<0.5,0.4,0>;
#declare BOTTOM_COLOR_2=<0.4,0.5,0>;
#declare TOP_COLOR_1=<0.5,0.5,0>;
#declare TOP_COLOR_2=<.3,.8,0>;
#declare COLOR_TURB=.5;
#declare TRANSITION_BOTTOM_TOP=0.4;
#declare TRANSITION_TURB=.25;
#declare FOLIAGE_GLOSS=0.0;
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
