//XXXXXXXXXXXXXXXXXXXXX S E T T I N G S XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
//TREE
#declare BRANCHES=40;
#declare TWIGS=70*BRANCHES;
#declare BUNCHES=1*TWIGS;
#declare LEAVES=1*BUNCHES;
#declare BLOSSOMS=0*BUNCHES;
#declare ROOTS=5;
#declare BRANCH_RANDOM=13.77;
#declare TWIG_RANDOM=77.37;
#declare ROOT_RANDOM=13;
//TRUNK
#declare TRUNK_RADIUS=26;
#declare TRUNK_STRENGTH=1;
#declare TRUNK_BEND_X=-20;
#declare TRUNK_BEND_Z=20;
#declare TRUNK_BEND_X_FREQUENCY=1.5;
#declare TRUNK_BEND_Z_FREQUENCY=1.5;
#declare TRUNK_CURVE=5;
#declare TRUNK_CURVE_FREQUENCY=3;
#declare TRUNK_SNAG=0;
#declare TRUNK_SNAG_FREQUENCY=10;
#declare TRUNK_SPIRAL=35;
#declare TRUNK_TAPER=.75;
#declare FIRST_BRANCH_AT_TRUNK=700;
#declare BRANCH_AREA_AT_TRUNK=50;
//BRANCH
#declare BRANCH_THICKNESS_CHANGE=.3;
#declare BRANCH_STRENGTH=1;
#declare BRANCH_BEND=120;
#declare BRANCH_BEND_FREQUENCY=.75;
#declare HORIZONTAL_BRANCH_BEND_SWITCH=0;
#declare EXTRA_NOISE_SWITCH=0;
#declare BRANCH_CURVE=0;
#declare BRANCH_CURVE_FREQUENCY=3;
#declare HORIZONTAL_BRANCH_CURVE_SWITCH=1;
#declare BRANCH_LONGITUDINAL_CURVE=1;
#declare BRANCH_SNAG=0;
#declare BRANCH_SNAG_FREQUENCY=5;
#declare BRANCH_REDUCTION=.0;
#declare BRANCH_TAPER=.6;
#declare BRANCH_END_EQUALIZER=0;
#declare BRANCH_TIP=0;
#declare BRANCH_TURN_SWITCH=0;
#declare BRANCH_ALTERNATE_SWITCH=0;
#declare BRANCH_SPIRAL=0;
#declare BRANCH_ANGLE=-20;
#declare BRANCH_ANGLE_SCOPE=10;
#declare BRANCH_ALIGNMENT=.9;
#declare STRAIGHTEN_TOWARDS_TOP=0.6;
#declare FIRST_TWIG_AT_BRANCH=50;
#declare TWIG_AREA_AT_BRANCH=350;
//TWIG
#declare TWIG_STRENGTH=.0;
#declare TWIG_THICKNESS_CHANGE=1;
#declare HORIZONTAL_TWIG_ANGLE=0;
#declare VERTICAL_TWIG_ANGLE=30;
#declare HORIZONTAL_TWIG_ANGLE_SCOPE=10;
#declare VERTICAL_TWIG_ANGLE_SCOPE=10;
#declare HORIZONTAL_TWIG_ALIGNMENT=.9;
#declare VERTICAL_TWIG_ALIGNMENT=1.5;
#declare TWIG_TURN_SWITCH=0;
#declare TWIG_ALTERNATE_SWITCH=1;
#declare TWIG_CURVE_ADJUSTMENT=0;
#declare TWIG_CURVE_FREQUENCY_ADJUSTMENT=0;
#declare TWIG_TAPER=1;
#declare TWIG_TIP=0;
#declare STRAIGHTEN_TOWARDS_BRANCH_END=0;
#declare TWIG_RAMIFICATION_ORDER=0;
#declare LAST_RAMIFICATION_NUMBER=5;
#declare TWIG_RAMIFICATION_THICKNESS_CHANGE=1;
#declare TWIG_RAMIFICATION_CURVE_ADJUSTMENT=1;
#declare RAMI_CURVE_FREQUENCY_ADJUSTMENT=1;
#declare TWIG_RAMIFICATION_STRENGTH=.5;
#declare FIRST_BUNCH_AT_TWIG=0;
#declare BUNCH_AREA_AT_TWIG=1;
//BUNCH
#declare BUNCH_MAJOR_RADIUS=0;
#declare BUNCH_MINOR_RADIUS=0;
#declare HORIZONTAL_BUNCH_FUNNEL=5;
#declare VERTICAL_BUNCH_FUNNEL=5;
#declare ROTATION_BUNCH_FUNNEL=0;
#declare HORIZONTAL_BUNCH_ANGLE=80;
#declare VERTICAL_BUNCH_ANGLE=0;
#declare HORIZONTAL_BUNCH_ANGLE_SCOPE=5;
#declare VERTICAL_BUNCH_ANGLE_SCOPE=10;
#declare BUNCH_TURN_SWITCH=0;
#declare BUNCH_TURN_SHIFT=0;
#declare BUNCH_ALTERNATE_SWITCH=1;
#declare HORIZONTAL_BUNCH_ALIGNMENT=1;
#declare VERTICAL_BUNCH_ALIGNMENT=.5;
#declare BUNCH_TAPER_OFF_AT_TWIG=.0;
#declare BUNCH_TAPER_OFF_AT_BRANCH=-1.;
#declare BUNCH_TAPER_OFF_AT_TREE=0;
#declare BUNCH_ARC_AT_TWIG=<0,0,0>; 
#declare BUNCH_ARC_AT_BRANCH=<0.25,0,0>;
#declare BUNCH_DEFORM=<1,1,1>;
//LEAF 
#include "TOMLEAF.inc"
#declare LEAF_TYPE=HF_PALMLEAF
#declare LEAF_LENGTH=80;
#declare LEAF_BREADTH=15;
#declare LEAF_HEIGHT=20;
#declare MAX_LEAF_TILT=10;
#declare MAX_LEAF_TURN=10;
#declare LEAF_INCLINATION=35;
#declare LEAF_INCLINATION_SCOPE=5;
//BLOSSOM
#declare BLOSSOM=BLOSSOM2
#declare BLOSSOM_LENGTH=15;
#declare BLOSSOM_WIDTH=30;
#declare BLOSSOM_INCLINATION=0;
#declare BLOSSOM_COLOR=<1,1,1>;
//ROOT
#declare FIRST_ROOT_AT_TRUNK=150;
#declare ROOT_LENGTH=300;
#declare ROOT_THICKNESS_CHANGE=.8;
#declare ROOT_STRENGTH=2;
#declare ROOT_BEND=50;
#declare ROOT_BEND_FREQUENCY=1.5;
#declare ROOT_CURVE=15;
#declare ROOT_CURVE_FREQUENCY=5;
#declare ROOT_SNAG=5;
#declare ROOT_SNAG_FREQUENCY=10;
#declare ROOT_TURN_SWITCH=1;
#declare ROOT_ANGLE=70;
#declare ROOT_ALIGNMENT=.0;
//BARK
#declare SUNKEN_TRUNK_COLOR=<-.2,-.1,0>;
#declare RAISED_TRUNK_COLOR=<0.5,0.3,0>;
#declare FOLIAGE_COLOR_AT_BRANCH_END=1;
#declare TRUNK_SCAR_WIDTH=45;
#declare TRUNK_SCAR_HEIGHT=10;
#declare HORIZONTAL_SCAR_SHRINKING=.7;
#declare VERTICAL_SCAR_SHRINKING=3;
#declare SCAR_DEPTH=1; 
#declare PALM_TRUNK=0.9;
#declare BARK_PROFILE=1;
#declare BRANCH_BARK_PROFILE_CHANGE=1;
#declare BRANCH_BARK_PROFILE_TAPER_OFF=1;
#declare ROOT_BARK_PROFILE_CHANGE=.7;
//FOLIAGECOLOR
#declare BOTTOM_COLOR_1=<0.65,0.55,0>;
#declare BOTTOM_COLOR_2=<0.4,0.3,0>;
#declare TOP_COLOR_1=<0.3,0.4,0>;
#declare TOP_COLOR_2=<.4,.7,0>;
#declare COLOR_TURB=2;
#declare TRANSITION_BOTTOM_TOP=0.5;
#declare TRANSITION_TURB=.5;
#declare FOLIAGE_GLOSS=0.25;
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX126
